-- main.lua  for sobel.love - an edge detection kernal

require 'colors'
require 'shortcuts'
require "kernal"

function love.load()
	love.graphics.setBackgroundColor( 255, 255, 255 )
	--kernal = {{1, 2,  1}, {0, 0, 0}, {-1, -2, -1}}
	img		= gr.newImage( "London.jpg" )
	local h, w = img:getHeight(), img:getWidth()
	kernal:send('pixel_size', {1/w, 1/h})
	h, w = img:getHeight(), img:getWidth()
	canvas1 = love.graphics.newCanvas( w, h )
	canvas2 = love.graphics.newCanvas( w, h )
	show 	= { sobel	= true}
	gr.setFont( gr.newFont( 18 ) )
	updateEffects()
	end

function love.update( dt )
	end

function love.draw()

	gr.draw( canvas2 )
	end

function love.keypressed( key )
	if key == 'escape'	then love.event.push('quit')			end
	if key == 's'		then show.sobel		= not show.sobel		end
	updateEffects()
	end

function updateEffects()	-- creates canvas3 containing image with effects
	copyCanvas( img, canvas1 )				-- img > canvas1
	if show.sobel then
		addEffect( kernal, canvas1, canvas2 )	-- canvas1 > canvas2 (fogged)
		else
		copyCanvas( canvas1, canvas2 )		-- or canvas1 > canvas (unmodified)
		end
	gr.setCanvas( canvas2 )				-- add parameter setting display
		gr.setColor( to "red" )
		gr.print("<s> key toggles Sobel effect",    10, 475 )
		gr.setColor( to "white" )
	gr.setCanvas(  )
	end

function addEffect( effect, sourceCanvas, destCanvas )
	gr.setPixelEffect( effect )
	destCanvas:clear()
	gr.setCanvas( destCanvas )
	--gr.setColor(255,0,0,255)
	gr.draw( sourceCanvas )
	gr.setCanvas()
	gr.setPixelEffect()
	end

function copyCanvas( sourceCanvas, destCanvas )
	gr.setCanvas( destCanvas )
	gr.draw( sourceCanvas )
	gr.setCanvas()
	end

